var Y = Object.defineProperty;
var Z = (s, e, t) => e in s ? Y(s, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : s[e] = t;
var E = (s, e, t) => Z(s, typeof e != "symbol" ? e + "" : e, t);
import { defineComponent as ee, ref as R, shallowRef as j, openBlock as N, createElementBlock as z, createElementVNode as te, normalizeClass as ne, createCommentVNode as re } from "vue";
/**
  postmate - A powerful, simple, promise-based postMessage library
  @version v1.6.0
  @link https://github.com/dollarshaveclub/postmate
  @author Jacob Kelley <jakie8@gmail.com>
  @license MIT
**/
var v = "application/x-postmate-v1+json", ie = 5, se = 0, oe = function() {
  return ++se;
}, d = function() {
  var e;
  return g.debug ? (e = console).log.apply(e, arguments) : null;
}, ae = function(e) {
  var t = document.createElement("a");
  t.href = e;
  var n = t.protocol.length > 4 ? t.protocol : window.location.protocol, r = t.host.length ? t.port === "80" || t.port === "443" ? t.hostname : t.host : window.location.host;
  return t.origin || n + "//" + r;
}, le = {
  handshake: 1,
  "handshake-reply": 1,
  call: 1,
  emit: 1,
  reply: 1,
  request: 1
  /**
   * Ensures that a message is safe to interpret
   * @param  {Object} message The postmate message being sent
   * @param  {String|Boolean} allowedOrigin The whitelisted origin or false to skip origin check
   * @return {Boolean}
   */
}, $ = function(e, t) {
  return !(typeof t == "string" && e.origin !== t || !e.data || typeof e.data == "object" && !("postmate" in e.data) || e.data.type !== v || !le[e.data.postmate]);
}, ce = function(e, t) {
  var n = typeof e[t] == "function" ? e[t]() : e[t];
  return g.Promise.resolve(n);
}, de = /* @__PURE__ */ function() {
  function s(t) {
    var n = this;
    this.parent = t.parent, this.frame = t.frame, this.child = t.child, this.childOrigin = t.childOrigin, this.events = {}, process.env.NODE_ENV !== "production" && (d("Parent: Registering API"), d("Parent: Awaiting messages...")), this.listener = function(r) {
      if (!$(r, n.childOrigin)) return !1;
      var a = ((r || {}).data || {}).value || {}, i = a.data, o = a.name;
      r.data.postmate === "emit" && (process.env.NODE_ENV !== "production" && d("Parent: Received event emission: " + o), o in n.events && n.events[o].forEach(function(l) {
        l.call(n, i);
      }));
    }, this.parent.addEventListener("message", this.listener, !1), process.env.NODE_ENV !== "production" && d("Parent: Awaiting event emissions from Child");
  }
  var e = s.prototype;
  return e.get = function(n) {
    var r = this;
    return new g.Promise(function(a) {
      var i = oe(), o = function l(c) {
        c.data.uid === i && c.data.postmate === "reply" && (r.parent.removeEventListener("message", l, !1), a(c.data.value));
      };
      r.parent.addEventListener("message", o, !1), r.child.postMessage({
        postmate: "request",
        type: v,
        property: n,
        uid: i
      }, r.childOrigin);
    });
  }, e.call = function(n, r) {
    this.child.postMessage({
      postmate: "call",
      type: v,
      property: n,
      data: r
    }, this.childOrigin);
  }, e.on = function(n, r) {
    this.events[n] || (this.events[n] = []), this.events[n].push(r);
  }, e.destroy = function() {
    process.env.NODE_ENV !== "production" && d("Parent: Destroying Postmate instance"), window.removeEventListener("message", this.listener, !1), this.frame.parentNode.removeChild(this.frame);
  }, s;
}(), fe = /* @__PURE__ */ function() {
  function s(t) {
    var n = this;
    this.model = t.model, this.parent = t.parent, this.parentOrigin = t.parentOrigin, this.child = t.child, process.env.NODE_ENV !== "production" && (d("Child: Registering API"), d("Child: Awaiting messages...")), this.child.addEventListener("message", function(r) {
      if ($(r, n.parentOrigin)) {
        process.env.NODE_ENV !== "production" && d("Child: Received request", r.data);
        var a = r.data, i = a.property, o = a.uid, l = a.data;
        if (r.data.postmate === "call") {
          i in n.model && typeof n.model[i] == "function" && n.model[i](l);
          return;
        }
        ce(n.model, i).then(function(c) {
          return r.source.postMessage({
            property: i,
            postmate: "reply",
            type: v,
            uid: o,
            value: c
          }, r.origin);
        });
      }
    });
  }
  var e = s.prototype;
  return e.emit = function(n, r) {
    process.env.NODE_ENV !== "production" && d('Child: Emitting Event "' + n + '"', r), this.parent.postMessage({
      postmate: "emit",
      type: v,
      value: {
        name: n,
        data: r
      }
    }, this.parentOrigin);
  }, s;
}(), g = /* @__PURE__ */ function() {
  function s(t) {
    var n = t.container, r = n === void 0 ? typeof r < "u" ? r : document.body : n, a = t.model, i = t.url, o = t.name, l = t.classListArray, c = l === void 0 ? [] : l, h = t.frame;
    return this.parent = window, h ? this.frame = h : (this.frame = document.createElement("iframe"), this.frame.name = o || "", this.frame.classList.add.apply(this.frame.classList, c)), r.appendChild(this.frame), this.child = this.frame.contentWindow || this.frame.contentDocument.parentWindow, this.model = a || {}, this.sendHandshake(i);
  }
  var e = s.prototype;
  return e.sendHandshake = function(n) {
    var r = this, a = ae(n), i = 0, o;
    return new s.Promise(function(l, c) {
      var h = function k(A) {
        return $(A, a) ? A.data.postmate === "handshake-reply" ? (clearInterval(o), process.env.NODE_ENV !== "production" && d("Parent: Received handshake reply from Child"), r.parent.removeEventListener("message", k, !1), r.childOrigin = A.origin, process.env.NODE_ENV !== "production" && d("Parent: Saving Child origin", r.childOrigin), l(new de(r))) : (process.env.NODE_ENV !== "production" && d("Parent: Invalid handshake reply"), c("Failed handshake")) : !1;
      };
      r.parent.addEventListener("message", h, !1);
      var I = function() {
        i++, process.env.NODE_ENV !== "production" && d("Parent: Sending handshake attempt " + i, {
          childOrigin: a
        }), r.child.postMessage({
          postmate: "handshake",
          type: v,
          model: r.model
        }, a), i === ie && clearInterval(o);
      }, M = function() {
        I(), o = setInterval(I, 500);
      };
      r.frame.attachEvent ? r.frame.attachEvent("onload", M) : r.frame.addEventListener("load", M), process.env.NODE_ENV !== "production" && d("Parent: Loading frame", {
        url: n
      }), r.frame.src = n;
    });
  }, s;
}();
g.debug = !1;
g.Promise = function() {
  try {
    return window ? window.Promise : Promise;
  } catch {
    return null;
  }
}();
g.Model = /* @__PURE__ */ function() {
  function s(t) {
    return this.child = window, this.model = t, this.parent = this.child.parent, this.sendHandshakeReply();
  }
  var e = s.prototype;
  return e.sendHandshakeReply = function() {
    var n = this;
    return new g.Promise(function(r, a) {
      var i = function o(l) {
        if (l.data.postmate) {
          if (l.data.postmate === "handshake") {
            process.env.NODE_ENV !== "production" && d("Child: Received handshake from Parent"), n.child.removeEventListener("message", o, !1), process.env.NODE_ENV !== "production" && d("Child: Sending handshake reply to Parent"), l.source.postMessage({
              postmate: "handshake-reply",
              type: v
            }, l.origin), n.parentOrigin = l.origin;
            var c = l.data.model;
            return c && (Object.keys(c).forEach(function(h) {
              n.model[h] = c[h];
            }), process.env.NODE_ENV !== "production" && d("Child: Inherited and extended model from Parent")), process.env.NODE_ENV !== "production" && d("Child: Saving Parent origin", n.parentOrigin), r(new fe(n));
          }
          return a("Handshake Reply Failed");
        }
      };
      n.child.addEventListener("message", i, !1);
    });
  }, s;
}();
class W {
  constructor(e, t, n) {
    E(this, "emitter");
    E(this, "container");
    E(this, "options");
    this.emitter = e, this.container = t, this.options = n || {};
  }
  createFrame() {
    const e = document.createElement("iframe");
    return e.name = "cfp-iframe", e.setAttribute("style", "position:absolute;top:0;left:0;width:100%;height:100%;border:0"), e;
  }
}
class ue extends W {
  constructor() {
    super(...arguments);
    E(this, "parent");
  }
  async play(t, n) {
    return new Promise(async (r) => {
      const a = this.options.presentationAnimationEngineIframeUrl ? this.options.presentationAnimationEngineIframeUrl : `${this.options.engineBaseUrl ? this.options.engineBaseUrl : ""}/cf-player/presentation-engine/index.html`, i = await new g({
        container: this.container,
        // @ts-ignore
        frame: this.createFrame(),
        url: a,
        model: {
          playMetas: t.animation,
          defaultPosition: n.position ? n.position : void 0
        }
      });
      let o = !1;
      i.on("page-changed", (l) => {
        this.emitter.emit("pageUpdate", l), o || (o = !0, r());
      }), this.parent = i;
    });
  }
  async prev() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    await this.parent.get("prev");
  }
  async next() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    await this.parent.get("next");
  }
  async goto(t) {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    t.step = t.step ? t.step : 1, this.parent.call("goto", t);
  }
  async position() {
    if (!this.parent)
      throw new Error("No postmate handshake.");
    return await this.parent.get("position");
  }
  async destroy() {
    this.parent && this.parent.destroy();
  }
}
const m = /* @__PURE__ */ new WeakMap(), y = /* @__PURE__ */ new WeakMap(), p = /* @__PURE__ */ new WeakMap(), D = Symbol("anyProducer"), B = Promise.resolve(), x = Symbol("listenerAdded"), S = Symbol("listenerRemoved");
let V = !1, T = !1;
const U = (s) => typeof s == "string" || typeof s == "symbol" || typeof s == "number";
function b(s) {
  if (!U(s))
    throw new TypeError("`eventName` must be a string, symbol, or number");
}
function L(s) {
  if (typeof s != "function")
    throw new TypeError("listener must be a function");
}
function P(s, e) {
  const t = y.get(s);
  if (t.has(e))
    return t.get(e);
}
function _(s, e) {
  const t = U(e) ? e : D, n = p.get(s);
  if (n.has(t))
    return n.get(t);
}
function he(s, e, t) {
  const n = p.get(s);
  if (n.has(e))
    for (const r of n.get(e))
      r.enqueue(t);
  if (n.has(D)) {
    const r = Promise.all([e, t]);
    for (const a of n.get(D))
      a.enqueue(r);
  }
}
function q(s, e) {
  e = Array.isArray(e) ? e : [e];
  let t = !1, n = () => {
  }, r = [];
  const a = {
    enqueue(i) {
      r.push(i), n();
    },
    finish() {
      t = !0, n();
    }
  };
  for (const i of e) {
    let o = _(s, i);
    o || (o = /* @__PURE__ */ new Set(), p.get(s).set(i, o)), o.add(a);
  }
  return {
    async next() {
      return r ? r.length === 0 ? t ? (r = void 0, this.next()) : (await new Promise((i) => {
        n = i;
      }), this.next()) : {
        done: !1,
        value: await r.shift()
      } : { done: !0 };
    },
    async return(i) {
      r = void 0;
      for (const o of e) {
        const l = _(s, o);
        l && (l.delete(a), l.size === 0 && p.get(s).delete(o));
      }
      return n(), arguments.length > 0 ? { done: !0, value: await i } : { done: !0 };
    },
    [Symbol.asyncIterator]() {
      return this;
    }
  };
}
function H(s) {
  if (s === void 0)
    return F;
  if (!Array.isArray(s))
    throw new TypeError("`methodNames` must be an array of strings");
  for (const e of s)
    if (!F.includes(e))
      throw typeof e != "string" ? new TypeError("`methodNames` element must be a string") : new Error(`${e} is not Emittery method`);
  return s;
}
const O = (s) => s === x || s === S;
function C(s, e, t) {
  if (O(e))
    try {
      V = !0, s.emit(e, t);
    } finally {
      V = !1;
    }
}
class w {
  static mixin(e, t) {
    return t = H(t), (n) => {
      if (typeof n != "function")
        throw new TypeError("`target` must be function");
      for (const i of t)
        if (n.prototype[i] !== void 0)
          throw new Error(`The property \`${i}\` already exists on \`target\``);
      function r() {
        return Object.defineProperty(this, e, {
          enumerable: !1,
          value: new w()
        }), this[e];
      }
      Object.defineProperty(n.prototype, e, {
        enumerable: !1,
        get: r
      });
      const a = (i) => function(...o) {
        return this[e][i](...o);
      };
      for (const i of t)
        Object.defineProperty(n.prototype, i, {
          enumerable: !1,
          value: a(i)
        });
      return n;
    };
  }
  static get isDebugEnabled() {
    var t;
    if (typeof ((t = globalThis.process) == null ? void 0 : t.env) != "object")
      return T;
    const { env: e } = globalThis.process ?? { env: {} };
    return e.DEBUG === "emittery" || e.DEBUG === "*" || T;
  }
  static set isDebugEnabled(e) {
    T = e;
  }
  constructor(e = {}) {
    m.set(this, /* @__PURE__ */ new Set()), y.set(this, /* @__PURE__ */ new Map()), p.set(this, /* @__PURE__ */ new Map()), p.get(this).set(D, /* @__PURE__ */ new Set()), this.debug = e.debug ?? {}, this.debug.enabled === void 0 && (this.debug.enabled = !1), this.debug.logger || (this.debug.logger = (t, n, r, a) => {
      try {
        a = JSON.stringify(a);
      } catch {
        a = `Object with the following keys failed to stringify: ${Object.keys(a).join(",")}`;
      }
      (typeof r == "symbol" || typeof r == "number") && (r = r.toString());
      const i = /* @__PURE__ */ new Date(), o = `${i.getHours()}:${i.getMinutes()}:${i.getSeconds()}.${i.getMilliseconds()}`;
      console.log(`[${o}][emittery:${t}][${n}] Event Name: ${r}
	data: ${a}`);
    });
  }
  logIfDebugEnabled(e, t, n) {
    (w.isDebugEnabled || this.debug.enabled) && this.debug.logger(e, this.debug.name, t, n);
  }
  on(e, t) {
    L(t), e = Array.isArray(e) ? e : [e];
    for (const n of e) {
      b(n);
      let r = P(this, n);
      r || (r = /* @__PURE__ */ new Set(), y.get(this).set(n, r)), r.add(t), this.logIfDebugEnabled("subscribe", n, void 0), O(n) || C(this, x, { eventName: n, listener: t });
    }
    return this.off.bind(this, e, t);
  }
  off(e, t) {
    L(t), e = Array.isArray(e) ? e : [e];
    for (const n of e) {
      b(n);
      const r = P(this, n);
      r && (r.delete(t), r.size === 0 && y.get(this).delete(n)), this.logIfDebugEnabled("unsubscribe", n, void 0), O(n) || C(this, S, { eventName: n, listener: t });
    }
  }
  once(e) {
    let t;
    const n = new Promise((r) => {
      t = this.on(e, (a) => {
        t(), r(a);
      });
    });
    return n.off = t, n;
  }
  events(e) {
    e = Array.isArray(e) ? e : [e];
    for (const t of e)
      b(t);
    return q(this, e);
  }
  async emit(e, t) {
    if (b(e), O(e) && !V)
      throw new TypeError("`eventName` cannot be meta event `listenerAdded` or `listenerRemoved`");
    this.logIfDebugEnabled("emit", e, t), he(this, e, t);
    const n = P(this, e) ?? /* @__PURE__ */ new Set(), r = m.get(this), a = [...n], i = O(e) ? [] : [...r];
    await B, await Promise.all([
      ...a.map(async (o) => {
        if (n.has(o))
          return o(t);
      }),
      ...i.map(async (o) => {
        if (r.has(o))
          return o(e, t);
      })
    ]);
  }
  async emitSerial(e, t) {
    if (b(e), O(e) && !V)
      throw new TypeError("`eventName` cannot be meta event `listenerAdded` or `listenerRemoved`");
    this.logIfDebugEnabled("emitSerial", e, t);
    const n = P(this, e) ?? /* @__PURE__ */ new Set(), r = m.get(this), a = [...n], i = [...r];
    await B;
    for (const o of a)
      n.has(o) && await o(t);
    for (const o of i)
      r.has(o) && await o(e, t);
  }
  onAny(e) {
    return L(e), this.logIfDebugEnabled("subscribeAny", void 0, void 0), m.get(this).add(e), C(this, x, { listener: e }), this.offAny.bind(this, e);
  }
  anyEvent() {
    return q(this);
  }
  offAny(e) {
    L(e), this.logIfDebugEnabled("unsubscribeAny", void 0, void 0), C(this, S, { listener: e }), m.get(this).delete(e);
  }
  clearListeners(e) {
    e = Array.isArray(e) ? e : [e];
    for (const t of e)
      if (this.logIfDebugEnabled("clear", t, void 0), U(t)) {
        const n = P(this, t);
        n && n.clear();
        const r = _(this, t);
        if (r) {
          for (const a of r)
            a.finish();
          r.clear();
        }
      } else {
        m.get(this).clear();
        for (const [n, r] of y.get(this).entries())
          r.clear(), y.get(this).delete(n);
        for (const [n, r] of p.get(this).entries()) {
          for (const a of r)
            a.finish();
          r.clear(), p.get(this).delete(n);
        }
      }
  }
  listenerCount(e) {
    var n, r, a;
    e = Array.isArray(e) ? e : [e];
    let t = 0;
    for (const i of e) {
      if (U(i)) {
        t += m.get(this).size + (((n = P(this, i)) == null ? void 0 : n.size) ?? 0) + (((r = _(this, i)) == null ? void 0 : r.size) ?? 0) + (((a = _(this)) == null ? void 0 : a.size) ?? 0);
        continue;
      }
      i !== void 0 && b(i), t += m.get(this).size;
      for (const o of y.get(this).values())
        t += o.size;
      for (const o of p.get(this).values())
        t += o.size;
    }
    return t;
  }
  bindMethods(e, t) {
    if (typeof e != "object" || e === null)
      throw new TypeError("`target` must be an object");
    t = H(t);
    for (const n of t) {
      if (e[n] !== void 0)
        throw new Error(`The property \`${n}\` already exists on \`target\``);
      Object.defineProperty(e, n, {
        enumerable: !1,
        value: this[n].bind(this)
      });
    }
  }
}
const F = Object.getOwnPropertyNames(w.prototype).filter((s) => s !== "constructor");
Object.defineProperty(w, "listenerAdded", {
  value: x,
  writable: !1,
  enumerable: !0,
  configurable: !1
});
Object.defineProperty(w, "listenerRemoved", {
  value: S,
  writable: !1,
  enumerable: !0,
  configurable: !1
});
class pe extends W {
  constructor() {
    super(...arguments);
    E(this, "postmate");
  }
  async play(t, n) {
    return new Promise(async (r) => {
      const a = this.options.imageEngineIframeUrl ? this.options.imageEngineIframeUrl : `${this.options.engineBaseUrl ? this.options.engineBaseUrl : ""}/cf-player/image-engine/index.html`, i = await new g({
        container: this.container,
        // @ts-ignore
        frame: this.createFrame(),
        url: a,
        model: {
          metas: t,
          defaultPosition: n.position ? n.position : void 0,
          vertical: n.vertical ? n.vertical : !1
        }
      });
      let o = !1;
      i.on("pageUpdate", (l) => {
        this.emitter.emit("pageUpdate", l), o || (o = !0, setTimeout(() => {
          r();
        }, 500));
      }), this.postmate = i;
    });
  }
  async prev() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    await this.postmate.get("prev");
  }
  async next() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    await this.postmate.get("next");
  }
  async goto(t) {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    this.postmate.call("goto", t);
  }
  async position() {
    if (!this.postmate)
      throw new Error("No postmate handshake.");
    return await this.postmate.get("position");
  }
  async destroy() {
    this.postmate && this.postmate.destroy();
  }
}
const ge = { class: "cf-player" }, ve = /* @__PURE__ */ ee({
  __name: "Player",
  props: {
    dark: { type: Boolean, default: !1 },
    engineBaseUrl: {},
    imageEngineIframeUrl: {},
    presentationAnimationEngineIframeUrl: {}
  },
  emits: ["pageUpdate"],
  setup(s, { expose: e, emit: t }) {
    const n = s, r = t, a = R(null), i = j(null), o = j(null), l = new w();
    l.on("pageUpdate", (f) => r("pageUpdate", f));
    const c = R(!1), h = async (f, u) => {
      if (console.log("call play"), !f.metas)
        return;
      o.value = f.metas, c.value = !0;
      const X = u && u.engine ? u.engine : void 0;
      return await K(o.value, X), await i.value.play(f.metas, u || {}), c.value = !1, Promise.resolve();
    }, I = () => {
      if (!(!o.value || !o.value.page))
        return o.value.page;
    }, M = async () => {
      if (!i.value)
        throw new Error("No engine.");
      return await i.value.position();
    }, k = async () => {
      if (!i.value)
        throw new Error("No engine.");
      await i.value.prev();
    }, A = async () => {
      if (!i.value)
        throw new Error("No engine.");
      await i.value.next();
    }, G = async (f) => {
      if (!i.value)
        throw new Error("No engine.");
      await i.value.goto(f);
    }, J = () => {
      if (!o.value || !o.value.page || !o.value.thumb)
        return [];
      const f = [];
      for (let u = 1; u <= o.value.page; u++)
        f.push({ page: u, url: o.value.thumb + u });
      return f;
    }, K = async (f, u) => {
      if (await Q(), f.type === "Presentation")
        u === "image" ? i.value = new pe(l, a.value, n) : u === "presentation" && (i.value = new ue(l, a.value, n));
      else throw f.type === "Word" ? new Error("Coming soon.") : f.type === "PDF" ? new Error("Coming soon.") : new Error("Not support file type.");
    }, Q = async () => {
      i.value && (await i.value.destroy(), i.value = null);
    };
    return e({
      play: h,
      totalPages: I,
      position: M,
      prev: k,
      next: A,
      goto: G,
      thumbs: J
    }), (f, u) => (N(), z("div", ge, [
      te("div", {
        ref_key: "container",
        ref: a,
        class: "cf-player__container"
      }, null, 512),
      c.value ? (N(), z("div", {
        key: 0,
        class: ne(["cf-player__mask", { "cf-player__mask--dark": f.dark }])
      }, " 文件加载中... ", 2)) : re("", !0)
    ]));
  }
});
export {
  ve as CloudFilePlayer
};
